
///////////////////////////////////////////////////////////////////////////
// This program is free software: you can redistribute it and/or modify  //
// it under the terms of the version 3 of the GNU General Public License //
// as published by the Free Software Foundation.                         //
//                                                                       //
// This program is distributed in the hope that it will be useful, but   //
// WITHOUT ANY WARRANTY; without even the implied warranty of            //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      //
// General Public License for more details.                              //
//                                                                       //
// You should have received a copy of the GNU General Public License     //
// along with this program. If not, see <http://www.gnu.org/licenses/>.  //
//                                                                       //
// Written by Francois Fleuret, (C) IDIAP                                //
// Contact <francois.fleuret@idiap.ch> for comments & bug reports        //
///////////////////////////////////////////////////////////////////////////

#ifndef PI_FEATURE_FAMILY_H
#define PI_FEATURE_FAMILY_H

#include "misc.h"
#include "pose_cell_set.h"
#include "pi_feature.h"

class PiFeatureFamily : public Storable {
  int _nb_features;
  PiFeature *_pi_features;

public:
  PiFeatureFamily();
  ~PiFeatureFamily();

  inline int nb_features() { return _nb_features; }

  inline PiFeature *get_feature(int f) {
    ASSERT(f >= 0 && f < _nb_features);
    return _pi_features + f;
  }

  void read(istream *is);
  void write(ostream *os);

  void resize(int nb_features);
  void randomize(int level);

  void extract(PiFeatureFamily *pi_feature_family, bool *used_features, int *new_feature_indexes);
};

#endif
