
///////////////////////////////////////////////////////////////////////////
// This program is free software: you can redistribute it and/or modify  //
// it under the terms of the version 3 of the GNU General Public License //
// as published by the Free Software Foundation.                         //
//                                                                       //
// This program is distributed in the hope that it will be useful, but   //
// WITHOUT ANY WARRANTY; without even the implied warranty of            //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      //
// General Public License for more details.                              //
//                                                                       //
// You should have received a copy of the GNU General Public License     //
// along with this program. If not, see <http://www.gnu.org/licenses/>.  //
//                                                                       //
// Written by Francois Fleuret, (C) IDIAP                                //
// Contact <francois.fleuret@idiap.ch> for comments & bug reports        //
///////////////////////////////////////////////////////////////////////////

/*

  This class displays a progress bar in text mode and computes a rough
  estimate of the remaining processing time.

*/

#ifndef PROGRESS_BAR_H
#define PROGRESS_BAR_H

#include <iostream>

using namespace std;

#include "misc.h"

class ProgressBar {
  bool _visible;
  scalar_t _value_max, _last_step;
  time_t _initial_time;
  const static int _width;
public:
  ProgressBar();
  void set_visible(bool visible);
  void init(ostream *out, scalar_t value_max);
  void refresh(ostream *out, scalar_t value);
  void finish(ostream *out);
};

#endif
